// generated from rosidl_generator_cpp/resource/idl__builder.hpp.em
// with input from hippo_msgs:msg/DepthStamped.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__DEPTH_STAMPED__BUILDER_HPP_
#define HIPPO_MSGS__MSG__DETAIL__DEPTH_STAMPED__BUILDER_HPP_

#include <algorithm>
#include <utility>

#include "hippo_msgs/msg/detail/depth_stamped__struct.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


namespace hippo_msgs
{

namespace msg
{

namespace builder
{

class Init_DepthStamped_vel_covariance
{
public:
  explicit Init_DepthStamped_vel_covariance(::hippo_msgs::msg::DepthStamped & msg)
  : msg_(msg)
  {}
  ::hippo_msgs::msg::DepthStamped vel_covariance(::hippo_msgs::msg::DepthStamped::_vel_covariance_type arg)
  {
    msg_.vel_covariance = std::move(arg);
    return std::move(msg_);
  }

private:
  ::hippo_msgs::msg::DepthStamped msg_;
};

class Init_DepthStamped_depth_covariance
{
public:
  explicit Init_DepthStamped_depth_covariance(::hippo_msgs::msg::DepthStamped & msg)
  : msg_(msg)
  {}
  Init_DepthStamped_vel_covariance depth_covariance(::hippo_msgs::msg::DepthStamped::_depth_covariance_type arg)
  {
    msg_.depth_covariance = std::move(arg);
    return Init_DepthStamped_vel_covariance(msg_);
  }

private:
  ::hippo_msgs::msg::DepthStamped msg_;
};

class Init_DepthStamped_z_vel
{
public:
  explicit Init_DepthStamped_z_vel(::hippo_msgs::msg::DepthStamped & msg)
  : msg_(msg)
  {}
  Init_DepthStamped_depth_covariance z_vel(::hippo_msgs::msg::DepthStamped::_z_vel_type arg)
  {
    msg_.z_vel = std::move(arg);
    return Init_DepthStamped_depth_covariance(msg_);
  }

private:
  ::hippo_msgs::msg::DepthStamped msg_;
};

class Init_DepthStamped_depth
{
public:
  explicit Init_DepthStamped_depth(::hippo_msgs::msg::DepthStamped & msg)
  : msg_(msg)
  {}
  Init_DepthStamped_z_vel depth(::hippo_msgs::msg::DepthStamped::_depth_type arg)
  {
    msg_.depth = std::move(arg);
    return Init_DepthStamped_z_vel(msg_);
  }

private:
  ::hippo_msgs::msg::DepthStamped msg_;
};

class Init_DepthStamped_header
{
public:
  Init_DepthStamped_header()
  : msg_(::rosidl_runtime_cpp::MessageInitialization::SKIP)
  {}
  Init_DepthStamped_depth header(::hippo_msgs::msg::DepthStamped::_header_type arg)
  {
    msg_.header = std::move(arg);
    return Init_DepthStamped_depth(msg_);
  }

private:
  ::hippo_msgs::msg::DepthStamped msg_;
};

}  // namespace builder

}  // namespace msg

template<typename MessageType>
auto build();

template<>
inline
auto build<::hippo_msgs::msg::DepthStamped>()
{
  return hippo_msgs::msg::builder::Init_DepthStamped_header();
}

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__DEPTH_STAMPED__BUILDER_HPP_
