// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/NewtonGripperCommand.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__NEWTON_GRIPPER_COMMAND__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__NEWTON_GRIPPER_COMMAND__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__NewtonGripperCommand __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__NewtonGripperCommand __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct NewtonGripperCommand_
{
  using Type = NewtonGripperCommand_<ContainerAllocator>;

  explicit NewtonGripperCommand_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action = 0l;
    }
  }

  explicit NewtonGripperCommand_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->action = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _action_type =
    int32_t;
  _action_type action;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__action(
    const int32_t & _arg)
  {
    this->action = _arg;
    return *this;
  }

  // constant declarations
  static constexpr int32_t ACTION_NONE =
    0;
  static constexpr int32_t ACTION_OPEN =
    1;
  static constexpr int32_t ACTION_CLOSE =
    2;

  // pointer types
  using RawPtr =
    hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__NewtonGripperCommand
    std::shared_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__NewtonGripperCommand
    std::shared_ptr<hippo_msgs::msg::NewtonGripperCommand_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const NewtonGripperCommand_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->action != other.action) {
      return false;
    }
    return true;
  }
  bool operator!=(const NewtonGripperCommand_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct NewtonGripperCommand_

// alias to use template instance with default allocator
using NewtonGripperCommand =
  hippo_msgs::msg::NewtonGripperCommand_<std::allocator<void>>;

// constant definitions
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t NewtonGripperCommand_<ContainerAllocator>::ACTION_NONE;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t NewtonGripperCommand_<ContainerAllocator>::ACTION_OPEN;
#endif  // __cplusplus < 201703L
#if __cplusplus < 201703L
// static constexpr member variable definitions are only needed in C++14 and below, deprecated in C++17
template<typename ContainerAllocator>
constexpr int32_t NewtonGripperCommand_<ContainerAllocator>::ACTION_CLOSE;
#endif  // __cplusplus < 201703L

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__NEWTON_GRIPPER_COMMAND__STRUCT_HPP_
