// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/PathFollowerDebug.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__PATH_FOLLOWER_DEBUG__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__PATH_FOLLOWER_DEBUG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'error_vec'
// Member 'support_vec'
// Member 'direction_vec'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__PathFollowerDebug __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__PathFollowerDebug __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct PathFollowerDebug_
{
  using Type = PathFollowerDebug_<ContainerAllocator>;

  explicit PathFollowerDebug_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init),
    error_vec(_init),
    support_vec(_init),
    direction_vec(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->look_ahead_distance = 0.0;
      this->mode = 0l;
    }
  }

  explicit PathFollowerDebug_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    error_vec(_alloc, _init),
    support_vec(_alloc, _init),
    direction_vec(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->look_ahead_distance = 0.0;
      this->mode = 0l;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _error_vec_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _error_vec_type error_vec;
  using _support_vec_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _support_vec_type support_vec;
  using _direction_vec_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _direction_vec_type direction_vec;
  using _look_ahead_distance_type =
    double;
  _look_ahead_distance_type look_ahead_distance;
  using _mode_type =
    int32_t;
  _mode_type mode;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__error_vec(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->error_vec = _arg;
    return *this;
  }
  Type & set__support_vec(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->support_vec = _arg;
    return *this;
  }
  Type & set__direction_vec(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->direction_vec = _arg;
    return *this;
  }
  Type & set__look_ahead_distance(
    const double & _arg)
  {
    this->look_ahead_distance = _arg;
    return *this;
  }
  Type & set__mode(
    const int32_t & _arg)
  {
    this->mode = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__PathFollowerDebug
    std::shared_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__PathFollowerDebug
    std::shared_ptr<hippo_msgs::msg::PathFollowerDebug_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const PathFollowerDebug_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->error_vec != other.error_vec) {
      return false;
    }
    if (this->support_vec != other.support_vec) {
      return false;
    }
    if (this->direction_vec != other.direction_vec) {
      return false;
    }
    if (this->look_ahead_distance != other.look_ahead_distance) {
      return false;
    }
    if (this->mode != other.mode) {
      return false;
    }
    return true;
  }
  bool operator!=(const PathFollowerDebug_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct PathFollowerDebug_

// alias to use template instance with default allocator
using PathFollowerDebug =
  hippo_msgs::msg::PathFollowerDebug_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__PATH_FOLLOWER_DEBUG__STRUCT_HPP_
