// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_msgs:msg/PathFollowerDebug.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__PATH_FOLLOWER_DEBUG__TRAITS_HPP_
#define HIPPO_MSGS__MSG__DETAIL__PATH_FOLLOWER_DEBUG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_msgs/msg/detail/path_follower_debug__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'error_vec'
// Member 'support_vec'
// Member 'direction_vec'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace hippo_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const PathFollowerDebug & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: error_vec
  {
    out << "error_vec: ";
    to_flow_style_yaml(msg.error_vec, out);
    out << ", ";
  }

  // member: support_vec
  {
    out << "support_vec: ";
    to_flow_style_yaml(msg.support_vec, out);
    out << ", ";
  }

  // member: direction_vec
  {
    out << "direction_vec: ";
    to_flow_style_yaml(msg.direction_vec, out);
    out << ", ";
  }

  // member: look_ahead_distance
  {
    out << "look_ahead_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.look_ahead_distance, out);
    out << ", ";
  }

  // member: mode
  {
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const PathFollowerDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: error_vec
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "error_vec:\n";
    to_block_style_yaml(msg.error_vec, out, indentation + 2);
  }

  // member: support_vec
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "support_vec:\n";
    to_block_style_yaml(msg.support_vec, out, indentation + 2);
  }

  // member: direction_vec
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "direction_vec:\n";
    to_block_style_yaml(msg.direction_vec, out, indentation + 2);
  }

  // member: look_ahead_distance
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "look_ahead_distance: ";
    rosidl_generator_traits::value_to_yaml(msg.look_ahead_distance, out);
    out << "\n";
  }

  // member: mode
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "mode: ";
    rosidl_generator_traits::value_to_yaml(msg.mode, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const PathFollowerDebug & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_msgs::msg::PathFollowerDebug & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_msgs::msg::PathFollowerDebug & msg)
{
  return hippo_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_msgs::msg::PathFollowerDebug>()
{
  return "hippo_msgs::msg::PathFollowerDebug";
}

template<>
inline const char * name<hippo_msgs::msg::PathFollowerDebug>()
{
  return "hippo_msgs/msg/PathFollowerDebug";
}

template<>
struct has_fixed_size<hippo_msgs::msg::PathFollowerDebug>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value && has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_msgs::msg::PathFollowerDebug>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value && has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_msgs::msg::PathFollowerDebug>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_MSGS__MSG__DETAIL__PATH_FOLLOWER_DEBUG__TRAITS_HPP_
