// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/RangeMeasurement.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__RangeMeasurement __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__RangeMeasurement __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RangeMeasurement_
{
  using Type = RangeMeasurement_<ContainerAllocator>;

  explicit RangeMeasurement_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->range = 0.0;
    }
  }

  explicit RangeMeasurement_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->id = 0l;
      this->range = 0.0;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _id_type =
    int32_t;
  _id_type id;
  using _range_type =
    double;
  _range_type range;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__id(
    const int32_t & _arg)
  {
    this->id = _arg;
    return *this;
  }
  Type & set__range(
    const double & _arg)
  {
    this->range = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::msg::RangeMeasurement_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::RangeMeasurement_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__RangeMeasurement
    std::shared_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__RangeMeasurement
    std::shared_ptr<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RangeMeasurement_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->id != other.id) {
      return false;
    }
    if (this->range != other.range) {
      return false;
    }
    return true;
  }
  bool operator!=(const RangeMeasurement_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RangeMeasurement_

// alias to use template instance with default allocator
using RangeMeasurement =
  hippo_msgs::msg::RangeMeasurement_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT__STRUCT_HPP_
