// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/RangeMeasurementArray.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT_ARRAY__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT_ARRAY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"
// Member 'measurements'
#include "hippo_msgs/msg/detail/range_measurement__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__RangeMeasurementArray __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__RangeMeasurementArray __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct RangeMeasurementArray_
{
  using Type = RangeMeasurementArray_<ContainerAllocator>;

  explicit RangeMeasurementArray_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    (void)_init;
  }

  explicit RangeMeasurementArray_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _measurements_type =
    std::vector<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>>>;
  _measurements_type measurements;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__measurements(
    const std::vector<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::msg::RangeMeasurement_<ContainerAllocator>>> & _arg)
  {
    this->measurements = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__RangeMeasurementArray
    std::shared_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__RangeMeasurementArray
    std::shared_ptr<hippo_msgs::msg::RangeMeasurementArray_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const RangeMeasurementArray_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->measurements != other.measurements) {
      return false;
    }
    return true;
  }
  bool operator!=(const RangeMeasurementArray_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct RangeMeasurementArray_

// alias to use template instance with default allocator
using RangeMeasurementArray =
  hippo_msgs::msg::RangeMeasurementArray_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT_ARRAY__STRUCT_HPP_
