// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/AngularVelocity.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__ANGULAR_VELOCITY__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__ANGULAR_VELOCITY__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__AngularVelocity __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__AngularVelocity __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct AngularVelocity_
{
  using Type = AngularVelocity_<ContainerAllocator>;

  explicit AngularVelocity_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 3>::iterator, double>(this->body_rates.begin(), this->body_rates.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->body_rates_derivative.begin(), this->body_rates_derivative.end(), 0.0);
    }
  }

  explicit AngularVelocity_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    body_rates(_alloc),
    body_rates_derivative(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 3>::iterator, double>(this->body_rates.begin(), this->body_rates.end(), 0.0);
      std::fill<typename std::array<double, 3>::iterator, double>(this->body_rates_derivative.begin(), this->body_rates_derivative.end(), 0.0);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _body_rates_type =
    std::array<double, 3>;
  _body_rates_type body_rates;
  using _body_rates_derivative_type =
    std::array<double, 3>;
  _body_rates_derivative_type body_rates_derivative;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__body_rates(
    const std::array<double, 3> & _arg)
  {
    this->body_rates = _arg;
    return *this;
  }
  Type & set__body_rates_derivative(
    const std::array<double, 3> & _arg)
  {
    this->body_rates_derivative = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::msg::AngularVelocity_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::AngularVelocity_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::AngularVelocity_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::AngularVelocity_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__AngularVelocity
    std::shared_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__AngularVelocity
    std::shared_ptr<hippo_msgs::msg::AngularVelocity_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const AngularVelocity_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->body_rates != other.body_rates) {
      return false;
    }
    if (this->body_rates_derivative != other.body_rates_derivative) {
      return false;
    }
    return true;
  }
  bool operator!=(const AngularVelocity_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct AngularVelocity_

// alias to use template instance with default allocator
using AngularVelocity =
  hippo_msgs::msg::AngularVelocity_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__ANGULAR_VELOCITY__STRUCT_HPP_
