// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/DepthStamped.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__DEPTH_STAMPED__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__DEPTH_STAMPED__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__DepthStamped __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__DepthStamped __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct DepthStamped_
{
  using Type = DepthStamped_<ContainerAllocator>;

  explicit DepthStamped_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->depth = 0.0f;
      this->z_vel = 0.0f;
      this->depth_covariance = 0.0f;
      this->vel_covariance = 0.0f;
    }
  }

  explicit DepthStamped_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->depth = 0.0f;
      this->z_vel = 0.0f;
      this->depth_covariance = 0.0f;
      this->vel_covariance = 0.0f;
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _depth_type =
    float;
  _depth_type depth;
  using _z_vel_type =
    float;
  _z_vel_type z_vel;
  using _depth_covariance_type =
    float;
  _depth_covariance_type depth_covariance;
  using _vel_covariance_type =
    float;
  _vel_covariance_type vel_covariance;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__depth(
    const float & _arg)
  {
    this->depth = _arg;
    return *this;
  }
  Type & set__z_vel(
    const float & _arg)
  {
    this->z_vel = _arg;
    return *this;
  }
  Type & set__depth_covariance(
    const float & _arg)
  {
    this->depth_covariance = _arg;
    return *this;
  }
  Type & set__vel_covariance(
    const float & _arg)
  {
    this->vel_covariance = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::msg::DepthStamped_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::DepthStamped_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::DepthStamped_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::DepthStamped_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__DepthStamped
    std::shared_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__DepthStamped
    std::shared_ptr<hippo_msgs::msg::DepthStamped_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const DepthStamped_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->depth != other.depth) {
      return false;
    }
    if (this->z_vel != other.z_vel) {
      return false;
    }
    if (this->depth_covariance != other.depth_covariance) {
      return false;
    }
    if (this->vel_covariance != other.vel_covariance) {
      return false;
    }
    return true;
  }
  bool operator!=(const DepthStamped_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct DepthStamped_

// alias to use template instance with default allocator
using DepthStamped =
  hippo_msgs::msg::DepthStamped_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__DEPTH_STAMPED__STRUCT_HPP_
