// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:msg/EscRpms.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__ESC_RPMS__STRUCT_HPP_
#define HIPPO_MSGS__MSG__DETAIL__ESC_RPMS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__msg__EscRpms __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__msg__EscRpms __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct EscRpms_
{
  using Type = EscRpms_<ContainerAllocator>;

  explicit EscRpms_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_init)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 8>::iterator, double>(this->rpms.begin(), this->rpms.end(), 0.0);
      std::fill<typename std::array<double, 8>::iterator, double>(this->revolutions.begin(), this->revolutions.end(), 0.0);
      std::fill<typename std::array<int64_t, 8>::iterator, int64_t>(this->commutations.begin(), this->commutations.end(), 0ll);
    }
  }

  explicit EscRpms_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : header(_alloc, _init),
    rpms(_alloc),
    revolutions(_alloc),
    commutations(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      std::fill<typename std::array<double, 8>::iterator, double>(this->rpms.begin(), this->rpms.end(), 0.0);
      std::fill<typename std::array<double, 8>::iterator, double>(this->revolutions.begin(), this->revolutions.end(), 0.0);
      std::fill<typename std::array<int64_t, 8>::iterator, int64_t>(this->commutations.begin(), this->commutations.end(), 0ll);
    }
  }

  // field types and members
  using _header_type =
    std_msgs::msg::Header_<ContainerAllocator>;
  _header_type header;
  using _rpms_type =
    std::array<double, 8>;
  _rpms_type rpms;
  using _revolutions_type =
    std::array<double, 8>;
  _revolutions_type revolutions;
  using _commutations_type =
    std::array<int64_t, 8>;
  _commutations_type commutations;

  // setters for named parameter idiom
  Type & set__header(
    const std_msgs::msg::Header_<ContainerAllocator> & _arg)
  {
    this->header = _arg;
    return *this;
  }
  Type & set__rpms(
    const std::array<double, 8> & _arg)
  {
    this->rpms = _arg;
    return *this;
  }
  Type & set__revolutions(
    const std::array<double, 8> & _arg)
  {
    this->revolutions = _arg;
    return *this;
  }
  Type & set__commutations(
    const std::array<int64_t, 8> & _arg)
  {
    this->commutations = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::msg::EscRpms_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::msg::EscRpms_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::EscRpms_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::msg::EscRpms_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__msg__EscRpms
    std::shared_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__msg__EscRpms
    std::shared_ptr<hippo_msgs::msg::EscRpms_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const EscRpms_ & other) const
  {
    if (this->header != other.header) {
      return false;
    }
    if (this->rpms != other.rpms) {
      return false;
    }
    if (this->revolutions != other.revolutions) {
      return false;
    }
    if (this->commutations != other.commutations) {
      return false;
    }
    return true;
  }
  bool operator!=(const EscRpms_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct EscRpms_

// alias to use template instance with default allocator
using EscRpms =
  hippo_msgs::msg::EscRpms_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__MSG__DETAIL__ESC_RPMS__STRUCT_HPP_
