// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_msgs:msg/EscRpms.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__ESC_RPMS__TRAITS_HPP_
#define HIPPO_MSGS__MSG__DETAIL__ESC_RPMS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_msgs/msg/detail/esc_rpms__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"

namespace hippo_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const EscRpms & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: rpms
  {
    if (msg.rpms.size() == 0) {
      out << "rpms: []";
    } else {
      out << "rpms: [";
      size_t pending_items = msg.rpms.size();
      for (auto item : msg.rpms) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: revolutions
  {
    if (msg.revolutions.size() == 0) {
      out << "revolutions: []";
    } else {
      out << "revolutions: [";
      size_t pending_items = msg.revolutions.size();
      for (auto item : msg.revolutions) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: commutations
  {
    if (msg.commutations.size() == 0) {
      out << "commutations: []";
    } else {
      out << "commutations: [";
      size_t pending_items = msg.commutations.size();
      for (auto item : msg.commutations) {
        rosidl_generator_traits::value_to_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const EscRpms & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: rpms
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.rpms.size() == 0) {
      out << "rpms: []\n";
    } else {
      out << "rpms:\n";
      for (auto item : msg.rpms) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: revolutions
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.revolutions.size() == 0) {
      out << "revolutions: []\n";
    } else {
      out << "revolutions:\n";
      for (auto item : msg.revolutions) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }

  // member: commutations
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.commutations.size() == 0) {
      out << "commutations: []\n";
    } else {
      out << "commutations:\n";
      for (auto item : msg.commutations) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "- ";
        rosidl_generator_traits::value_to_yaml(item, out);
        out << "\n";
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const EscRpms & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_msgs::msg::EscRpms & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_msgs::msg::EscRpms & msg)
{
  return hippo_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_msgs::msg::EscRpms>()
{
  return "hippo_msgs::msg::EscRpms";
}

template<>
inline const char * name<hippo_msgs::msg::EscRpms>()
{
  return "hippo_msgs/msg/EscRpms";
}

template<>
struct has_fixed_size<hippo_msgs::msg::EscRpms>
  : std::integral_constant<bool, has_fixed_size<std_msgs::msg::Header>::value> {};

template<>
struct has_bounded_size<hippo_msgs::msg::EscRpms>
  : std::integral_constant<bool, has_bounded_size<std_msgs::msg::Header>::value> {};

template<>
struct is_message<hippo_msgs::msg::EscRpms>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_MSGS__MSG__DETAIL__ESC_RPMS__TRAITS_HPP_
