// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_msgs:msg/RangeMeasurementArray.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT_ARRAY__TRAITS_HPP_
#define HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT_ARRAY__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_msgs/msg/detail/range_measurement_array__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'header'
#include "std_msgs/msg/detail/header__traits.hpp"
// Member 'measurements'
#include "hippo_msgs/msg/detail/range_measurement__traits.hpp"

namespace hippo_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const RangeMeasurementArray & msg,
  std::ostream & out)
{
  out << "{";
  // member: header
  {
    out << "header: ";
    to_flow_style_yaml(msg.header, out);
    out << ", ";
  }

  // member: measurements
  {
    if (msg.measurements.size() == 0) {
      out << "measurements: []";
    } else {
      out << "measurements: [";
      size_t pending_items = msg.measurements.size();
      for (auto item : msg.measurements) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const RangeMeasurementArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: header
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "header:\n";
    to_block_style_yaml(msg.header, out, indentation + 2);
  }

  // member: measurements
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.measurements.size() == 0) {
      out << "measurements: []\n";
    } else {
      out << "measurements:\n";
      for (auto item : msg.measurements) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const RangeMeasurementArray & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace hippo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_msgs::msg::RangeMeasurementArray & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const hippo_msgs::msg::RangeMeasurementArray & msg)
{
  return hippo_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_msgs::msg::RangeMeasurementArray>()
{
  return "hippo_msgs::msg::RangeMeasurementArray";
}

template<>
inline const char * name<hippo_msgs::msg::RangeMeasurementArray>()
{
  return "hippo_msgs/msg/RangeMeasurementArray";
}

template<>
struct has_fixed_size<hippo_msgs::msg::RangeMeasurementArray>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hippo_msgs::msg::RangeMeasurementArray>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hippo_msgs::msg::RangeMeasurementArray>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_MSGS__MSG__DETAIL__RANGE_MEASUREMENT_ARRAY__TRAITS_HPP_
