// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from hippo_msgs:srv/SetAxis.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__SRV__DETAIL__SET_AXIS__STRUCT_H_
#define HIPPO_MSGS__SRV__DETAIL__SET_AXIS__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>


// Constants defined in the message

// Include directives for member types
// Member 'support_vector'
// Member 'direction_vector'
#include "geometry_msgs/msg/detail/vector3__struct.h"

/// Struct defined in srv/SetAxis in the package hippo_msgs.
typedef struct hippo_msgs__srv__SetAxis_Request
{
  geometry_msgs__msg__Vector3 support_vector;
  geometry_msgs__msg__Vector3 direction_vector;
} hippo_msgs__srv__SetAxis_Request;

// Struct for a sequence of hippo_msgs__srv__SetAxis_Request.
typedef struct hippo_msgs__srv__SetAxis_Request__Sequence
{
  hippo_msgs__srv__SetAxis_Request * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hippo_msgs__srv__SetAxis_Request__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'reason'
#include "rosidl_runtime_c/string.h"

/// Struct defined in srv/SetAxis in the package hippo_msgs.
typedef struct hippo_msgs__srv__SetAxis_Response
{
  bool success;
  rosidl_runtime_c__String reason;
} hippo_msgs__srv__SetAxis_Response;

// Struct for a sequence of hippo_msgs__srv__SetAxis_Response.
typedef struct hippo_msgs__srv__SetAxis_Response__Sequence
{
  hippo_msgs__srv__SetAxis_Response * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hippo_msgs__srv__SetAxis_Response__Sequence;

// Constants defined in the message

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.h"

// constants for array fields with an upper bound
// request
enum
{
  hippo_msgs__srv__SetAxis_Event__request__MAX_SIZE = 1
};
// response
enum
{
  hippo_msgs__srv__SetAxis_Event__response__MAX_SIZE = 1
};

/// Struct defined in srv/SetAxis in the package hippo_msgs.
typedef struct hippo_msgs__srv__SetAxis_Event
{
  service_msgs__msg__ServiceEventInfo info;
  hippo_msgs__srv__SetAxis_Request__Sequence request;
  hippo_msgs__srv__SetAxis_Response__Sequence response;
} hippo_msgs__srv__SetAxis_Event;

// Struct for a sequence of hippo_msgs__srv__SetAxis_Event.
typedef struct hippo_msgs__srv__SetAxis_Event__Sequence
{
  hippo_msgs__srv__SetAxis_Event * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} hippo_msgs__srv__SetAxis_Event__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // HIPPO_MSGS__SRV__DETAIL__SET_AXIS__STRUCT_H_
