// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:srv/SetAxis.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__SRV__DETAIL__SET_AXIS__STRUCT_HPP_
#define HIPPO_MSGS__SRV__DETAIL__SET_AXIS__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'support_vector'
// Member 'direction_vector'
#include "geometry_msgs/msg/detail/vector3__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__srv__SetAxis_Request __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__srv__SetAxis_Request __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetAxis_Request_
{
  using Type = SetAxis_Request_<ContainerAllocator>;

  explicit SetAxis_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : support_vector(_init),
    direction_vector(_init)
  {
    (void)_init;
  }

  explicit SetAxis_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : support_vector(_alloc, _init),
    direction_vector(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _support_vector_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _support_vector_type support_vector;
  using _direction_vector_type =
    geometry_msgs::msg::Vector3_<ContainerAllocator>;
  _direction_vector_type direction_vector;

  // setters for named parameter idiom
  Type & set__support_vector(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->support_vector = _arg;
    return *this;
  }
  Type & set__direction_vector(
    const geometry_msgs::msg::Vector3_<ContainerAllocator> & _arg)
  {
    this->direction_vector = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::srv::SetAxis_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::srv::SetAxis_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__srv__SetAxis_Request
    std::shared_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__srv__SetAxis_Request
    std::shared_ptr<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetAxis_Request_ & other) const
  {
    if (this->support_vector != other.support_vector) {
      return false;
    }
    if (this->direction_vector != other.direction_vector) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetAxis_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetAxis_Request_

// alias to use template instance with default allocator
using SetAxis_Request =
  hippo_msgs::srv::SetAxis_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace hippo_msgs


#ifndef _WIN32
# define DEPRECATED__hippo_msgs__srv__SetAxis_Response __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__srv__SetAxis_Response __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetAxis_Response_
{
  using Type = SetAxis_Response_<ContainerAllocator>;

  explicit SetAxis_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->reason = "";
    }
  }

  explicit SetAxis_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : reason(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->reason = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _reason_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _reason_type reason;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__reason(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->reason = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::srv::SetAxis_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::srv::SetAxis_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__srv__SetAxis_Response
    std::shared_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__srv__SetAxis_Response
    std::shared_ptr<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetAxis_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->reason != other.reason) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetAxis_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetAxis_Response_

// alias to use template instance with default allocator
using SetAxis_Response =
  hippo_msgs::srv::SetAxis_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace hippo_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__srv__SetAxis_Event __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__srv__SetAxis_Event __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetAxis_Event_
{
  using Type = SetAxis_Event_<ContainerAllocator>;

  explicit SetAxis_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit SetAxis_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetAxis_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetAxis_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::srv::SetAxis_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::srv::SetAxis_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetAxis_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetAxis_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__srv__SetAxis_Event
    std::shared_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__srv__SetAxis_Event
    std::shared_ptr<hippo_msgs::srv::SetAxis_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetAxis_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetAxis_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetAxis_Event_

// alias to use template instance with default allocator
using SetAxis_Event =
  hippo_msgs::srv::SetAxis_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace hippo_msgs

namespace hippo_msgs
{

namespace srv
{

struct SetAxis
{
  using Request = hippo_msgs::srv::SetAxis_Request;
  using Response = hippo_msgs::srv::SetAxis_Response;
  using Event = hippo_msgs::srv::SetAxis_Event;
};

}  // namespace srv

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__SRV__DETAIL__SET_AXIS__STRUCT_HPP_
