// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from hippo_msgs:srv/SetAxis.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__SRV__DETAIL__SET_AXIS__TRAITS_HPP_
#define HIPPO_MSGS__SRV__DETAIL__SET_AXIS__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "hippo_msgs/srv/detail/set_axis__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'support_vector'
// Member 'direction_vector'
#include "geometry_msgs/msg/detail/vector3__traits.hpp"

namespace hippo_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetAxis_Request & msg,
  std::ostream & out)
{
  out << "{";
  // member: support_vector
  {
    out << "support_vector: ";
    to_flow_style_yaml(msg.support_vector, out);
    out << ", ";
  }

  // member: direction_vector
  {
    out << "direction_vector: ";
    to_flow_style_yaml(msg.direction_vector, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetAxis_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: support_vector
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "support_vector:\n";
    to_block_style_yaml(msg.support_vector, out, indentation + 2);
  }

  // member: direction_vector
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "direction_vector:\n";
    to_block_style_yaml(msg.direction_vector, out, indentation + 2);
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetAxis_Request & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace hippo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_msgs::srv::SetAxis_Request & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const hippo_msgs::srv::SetAxis_Request & msg)
{
  return hippo_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_msgs::srv::SetAxis_Request>()
{
  return "hippo_msgs::srv::SetAxis_Request";
}

template<>
inline const char * name<hippo_msgs::srv::SetAxis_Request>()
{
  return "hippo_msgs/srv/SetAxis_Request";
}

template<>
struct has_fixed_size<hippo_msgs::srv::SetAxis_Request>
  : std::integral_constant<bool, has_fixed_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct has_bounded_size<hippo_msgs::srv::SetAxis_Request>
  : std::integral_constant<bool, has_bounded_size<geometry_msgs::msg::Vector3>::value> {};

template<>
struct is_message<hippo_msgs::srv::SetAxis_Request>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace hippo_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetAxis_Response & msg,
  std::ostream & out)
{
  out << "{";
  // member: success
  {
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << ", ";
  }

  // member: reason
  {
    out << "reason: ";
    rosidl_generator_traits::value_to_yaml(msg.reason, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetAxis_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: success
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "success: ";
    rosidl_generator_traits::value_to_yaml(msg.success, out);
    out << "\n";
  }

  // member: reason
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "reason: ";
    rosidl_generator_traits::value_to_yaml(msg.reason, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetAxis_Response & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace hippo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_msgs::srv::SetAxis_Response & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const hippo_msgs::srv::SetAxis_Response & msg)
{
  return hippo_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_msgs::srv::SetAxis_Response>()
{
  return "hippo_msgs::srv::SetAxis_Response";
}

template<>
inline const char * name<hippo_msgs::srv::SetAxis_Response>()
{
  return "hippo_msgs/srv/SetAxis_Response";
}

template<>
struct has_fixed_size<hippo_msgs::srv::SetAxis_Response>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hippo_msgs::srv::SetAxis_Response>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<hippo_msgs::srv::SetAxis_Response>
  : std::true_type {};

}  // namespace rosidl_generator_traits

// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__traits.hpp"

namespace hippo_msgs
{

namespace srv
{

inline void to_flow_style_yaml(
  const SetAxis_Event & msg,
  std::ostream & out)
{
  out << "{";
  // member: info
  {
    out << "info: ";
    to_flow_style_yaml(msg.info, out);
    out << ", ";
  }

  // member: request
  {
    if (msg.request.size() == 0) {
      out << "request: []";
    } else {
      out << "request: [";
      size_t pending_items = msg.request.size();
      for (auto item : msg.request) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
    out << ", ";
  }

  // member: response
  {
    if (msg.response.size() == 0) {
      out << "response: []";
    } else {
      out << "response: [";
      size_t pending_items = msg.response.size();
      for (auto item : msg.response) {
        to_flow_style_yaml(item, out);
        if (--pending_items > 0) {
          out << ", ";
        }
      }
      out << "]";
    }
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const SetAxis_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: info
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "info:\n";
    to_block_style_yaml(msg.info, out, indentation + 2);
  }

  // member: request
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.request.size() == 0) {
      out << "request: []\n";
    } else {
      out << "request:\n";
      for (auto item : msg.request) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }

  // member: response
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    if (msg.response.size() == 0) {
      out << "response: []\n";
    } else {
      out << "response:\n";
      for (auto item : msg.response) {
        if (indentation > 0) {
          out << std::string(indentation, ' ');
        }
        out << "-\n";
        to_block_style_yaml(item, out, indentation + 2);
      }
    }
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const SetAxis_Event & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace srv

}  // namespace hippo_msgs

namespace rosidl_generator_traits
{

[[deprecated("use hippo_msgs::srv::to_block_style_yaml() instead")]]
inline void to_yaml(
  const hippo_msgs::srv::SetAxis_Event & msg,
  std::ostream & out, size_t indentation = 0)
{
  hippo_msgs::srv::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use hippo_msgs::srv::to_yaml() instead")]]
inline std::string to_yaml(const hippo_msgs::srv::SetAxis_Event & msg)
{
  return hippo_msgs::srv::to_yaml(msg);
}

template<>
inline const char * data_type<hippo_msgs::srv::SetAxis_Event>()
{
  return "hippo_msgs::srv::SetAxis_Event";
}

template<>
inline const char * name<hippo_msgs::srv::SetAxis_Event>()
{
  return "hippo_msgs/srv/SetAxis_Event";
}

template<>
struct has_fixed_size<hippo_msgs::srv::SetAxis_Event>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<hippo_msgs::srv::SetAxis_Event>
  : std::integral_constant<bool, has_bounded_size<hippo_msgs::srv::SetAxis_Request>::value && has_bounded_size<hippo_msgs::srv::SetAxis_Response>::value && has_bounded_size<service_msgs::msg::ServiceEventInfo>::value> {};

template<>
struct is_message<hippo_msgs::srv::SetAxis_Event>
  : std::true_type {};

}  // namespace rosidl_generator_traits

namespace rosidl_generator_traits
{

template<>
inline const char * data_type<hippo_msgs::srv::SetAxis>()
{
  return "hippo_msgs::srv::SetAxis";
}

template<>
inline const char * name<hippo_msgs::srv::SetAxis>()
{
  return "hippo_msgs/srv/SetAxis";
}

template<>
struct has_fixed_size<hippo_msgs::srv::SetAxis>
  : std::integral_constant<
    bool,
    has_fixed_size<hippo_msgs::srv::SetAxis_Request>::value &&
    has_fixed_size<hippo_msgs::srv::SetAxis_Response>::value
  >
{
};

template<>
struct has_bounded_size<hippo_msgs::srv::SetAxis>
  : std::integral_constant<
    bool,
    has_bounded_size<hippo_msgs::srv::SetAxis_Request>::value &&
    has_bounded_size<hippo_msgs::srv::SetAxis_Response>::value
  >
{
};

template<>
struct is_service<hippo_msgs::srv::SetAxis>
  : std::true_type
{
};

template<>
struct is_service_request<hippo_msgs::srv::SetAxis_Request>
  : std::true_type
{
};

template<>
struct is_service_response<hippo_msgs::srv::SetAxis_Response>
  : std::true_type
{
};

}  // namespace rosidl_generator_traits

#endif  // HIPPO_MSGS__SRV__DETAIL__SET_AXIS__TRAITS_HPP_
