// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from hippo_msgs:srv/SetPath.idl
// generated code does not contain a copyright notice

#ifndef HIPPO_MSGS__SRV__DETAIL__SET_PATH__STRUCT_HPP_
#define HIPPO_MSGS__SRV__DETAIL__SET_PATH__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'path'
#include "hippo_msgs/msg/detail/path__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__srv__SetPath_Request __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__srv__SetPath_Request __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetPath_Request_
{
  using Type = SetPath_Request_<ContainerAllocator>;

  explicit SetPath_Request_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path(_init)
  {
    (void)_init;
  }

  explicit SetPath_Request_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : path(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _path_type =
    hippo_msgs::msg::Path_<ContainerAllocator>;
  _path_type path;

  // setters for named parameter idiom
  Type & set__path(
    const hippo_msgs::msg::Path_<ContainerAllocator> & _arg)
  {
    this->path = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::srv::SetPath_Request_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::srv::SetPath_Request_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetPath_Request_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetPath_Request_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__srv__SetPath_Request
    std::shared_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__srv__SetPath_Request
    std::shared_ptr<hippo_msgs::srv::SetPath_Request_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetPath_Request_ & other) const
  {
    if (this->path != other.path) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetPath_Request_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetPath_Request_

// alias to use template instance with default allocator
using SetPath_Request =
  hippo_msgs::srv::SetPath_Request_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace hippo_msgs


#ifndef _WIN32
# define DEPRECATED__hippo_msgs__srv__SetPath_Response __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__srv__SetPath_Response __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetPath_Response_
{
  using Type = SetPath_Response_<ContainerAllocator>;

  explicit SetPath_Response_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->reason = "";
    }
  }

  explicit SetPath_Response_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : reason(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->success = false;
      this->reason = "";
    }
  }

  // field types and members
  using _success_type =
    bool;
  _success_type success;
  using _reason_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _reason_type reason;

  // setters for named parameter idiom
  Type & set__success(
    const bool & _arg)
  {
    this->success = _arg;
    return *this;
  }
  Type & set__reason(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->reason = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::srv::SetPath_Response_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::srv::SetPath_Response_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetPath_Response_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetPath_Response_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__srv__SetPath_Response
    std::shared_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__srv__SetPath_Response
    std::shared_ptr<hippo_msgs::srv::SetPath_Response_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetPath_Response_ & other) const
  {
    if (this->success != other.success) {
      return false;
    }
    if (this->reason != other.reason) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetPath_Response_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetPath_Response_

// alias to use template instance with default allocator
using SetPath_Response =
  hippo_msgs::srv::SetPath_Response_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace hippo_msgs


// Include directives for member types
// Member 'info'
#include "service_msgs/msg/detail/service_event_info__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__hippo_msgs__srv__SetPath_Event __attribute__((deprecated))
#else
# define DEPRECATED__hippo_msgs__srv__SetPath_Event __declspec(deprecated)
#endif

namespace hippo_msgs
{

namespace srv
{

// message struct
template<class ContainerAllocator>
struct SetPath_Event_
{
  using Type = SetPath_Event_<ContainerAllocator>;

  explicit SetPath_Event_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_init)
  {
    (void)_init;
  }

  explicit SetPath_Event_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : info(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _info_type =
    service_msgs::msg::ServiceEventInfo_<ContainerAllocator>;
  _info_type info;
  using _request_type =
    rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>>>;
  _request_type request;
  using _response_type =
    rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>>>;
  _response_type response;

  // setters for named parameter idiom
  Type & set__info(
    const service_msgs::msg::ServiceEventInfo_<ContainerAllocator> & _arg)
  {
    this->info = _arg;
    return *this;
  }
  Type & set__request(
    const rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetPath_Request_<ContainerAllocator>>> & _arg)
  {
    this->request = _arg;
    return *this;
  }
  Type & set__response(
    const rosidl_runtime_cpp::BoundedVector<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>, 1, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<hippo_msgs::srv::SetPath_Response_<ContainerAllocator>>> & _arg)
  {
    this->response = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    hippo_msgs::srv::SetPath_Event_<ContainerAllocator> *;
  using ConstRawPtr =
    const hippo_msgs::srv::SetPath_Event_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetPath_Event_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      hippo_msgs::srv::SetPath_Event_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__hippo_msgs__srv__SetPath_Event
    std::shared_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__hippo_msgs__srv__SetPath_Event
    std::shared_ptr<hippo_msgs::srv::SetPath_Event_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const SetPath_Event_ & other) const
  {
    if (this->info != other.info) {
      return false;
    }
    if (this->request != other.request) {
      return false;
    }
    if (this->response != other.response) {
      return false;
    }
    return true;
  }
  bool operator!=(const SetPath_Event_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct SetPath_Event_

// alias to use template instance with default allocator
using SetPath_Event =
  hippo_msgs::srv::SetPath_Event_<std::allocator<void>>;

// constant definitions

}  // namespace srv

}  // namespace hippo_msgs

namespace hippo_msgs
{

namespace srv
{

struct SetPath
{
  using Request = hippo_msgs::srv::SetPath_Request;
  using Response = hippo_msgs::srv::SetPath_Response;
  using Event = hippo_msgs::srv::SetPath_Event;
};

}  // namespace srv

}  // namespace hippo_msgs

#endif  // HIPPO_MSGS__SRV__DETAIL__SET_PATH__STRUCT_HPP_
